from zExceptions import Unauthorized
if REQUEST is not None:
  raise Unauthorized

from DateTime import DateTime

portal = context.getPortalObject()
compute_node = context

tag = '%s_%s' % (compute_node.getUid(), script.id)
activate_kw = {'tag': tag}
if portal.portal_activities.countMessageWithTag(tag) > 0:
  # nothing to do
  return


def storeWorkflowComment(document, comment):
  portal.portal_workflow.doActionFor(document, 'edit_action', comment=comment)


def newOpenOrder():
  new_open_sale_order = portal.open_sale_order_module.newContent(portal_type="Open Sale Order")
  new_open_sale_order.edit(
    specialise=specialise,
    effective_date=DateTime(),
    activate_kw=activate_kw,
    destination=person.getRelativeUrl(),
    destination_decision=person.getRelativeUrl(),
    title="%s SlapOS Subscription" % person.getTitle()
  )

  new_open_sale_order.order(activate_kw=activate_kw)
  new_open_sale_order.validate(activate_kw=activate_kw)
  return new_open_sale_order

if 1:
  open_order = None
  person = compute_node.getSourceAdministrationValue(portal_type="Person")
  # Template document does not have person relation
  if person is not None:

    # Search an existing related open order
    open_order_line = portal.portal_catalog.getResultValue(
      portal_type='Open Sale Order Line',
      default_aggregate_uid=compute_node.getUid())

    is_open_order_creation_needed = False

    # Simply check that it has never been simulated
    if 0:#instance_tree.getSlapState() == 'destroy_requested':
      # Line should be deleted
      if (open_order_line is not None) and (open_order_line.getValidationState() == "invalidated"):
        instance_tree.converge(comment="Last open order: %s" % open_order_line.getRelativeUrl())
      elif open_order_line is None:
        # User has no Open Sale Order (likely).
        # No need to charge, as it was never allocated
        is_open_order_creation_needed = False
        instance_tree.converge(comment="No open order needed as it was never allocated")

    elif open_order_line is None:
      # Let's add
      is_open_order_creation_needed = True

    # Let's create the open order
    if is_open_order_creation_needed:
      open_sale_order = newOpenOrder()

      open_order_explanation = ""
      # Add lines
      open_order_line = open_sale_order.newContent(portal_type="Open Sale Order Line")

      hosting_subscription = portal.hosting_subscription_module.newContent(
        portal_type="Hosting Subscription",
        title=compute_node.getTitle()
      )
      hosting_subscription.validate()
      start_date = hosting_subscription.HostingSubscription_calculateSubscriptionStartDate()

      # Search for matching resource
      service_list = portal.portal_catalog(
        # XXX Hardcoded as temporary
        id='slapos_compute_node_subscription',
        portal_type='Service',
        validation_state='validated',
        use__relative_url='use/trade/sale'
      )
      service = [x for x in service_list if compute_node.getPortalType() in x.getRequiredAggregatedPortalTypeList()][0].getObject()
      edit_kw = {
        'quantity': 1,
        'resource_value': service,
        'quantity_unit': service.getQuantityUnit(),
        'base_contribution_list': service.getBaseContributionList(),
        'use': service.getUse()
      }

      open_order_line.edit(
        activate_kw=activate_kw,
        title=compute_node.getTitle(),
        start_date=start_date,
        # Ensure stop date value is higher than start date
        # it will be updated by OpenSaleOrder_updatePeriod
        stop_date=start_date + 1,
        # stop_date=calculateOpenOrderLineStopDate(open_sale_order_line,
        #         instance_tree, start_date_delta=start_date_delta),
        aggregate_value_list=[hosting_subscription, compute_node],
        **edit_kw
      )

      predicate_list = []
      inherited_trade_condition = open_sale_order.getSpecialiseValue()
      while inherited_trade_condition is not None:
        predicate_list.extend([
          x for x in inherited_trade_condition.contentValues(portal_type='Sale Supply Line')
          if x.getResource() == service.getRelativeUrl()
        ])
        inherited_trade_condition = inherited_trade_condition.getSpecialiseValue(portal_type=inherited_trade_condition.getPortalType())

      price = service.getPrice(
        context=open_order_line,
        predicate_list=predicate_list,
        default=None,
      )
      if price is None:
        raise NotImplementedError('Price must be defined')
      open_order_line.edit(
        price=price
      )

      storeWorkflowComment(open_order_line, "Created for %s" % compute_node.getRelativeUrl())
      # instance_tree.converge(comment="Last open order: %s" % open_sale_order_line.getRelativeUrl())
      open_order_explanation = "Added %s." % str(open_order_line.getId())

      storeWorkflowComment(open_sale_order, open_order_explanation)

      open_order = open_order_line.getParentValue()
      open_order.SaleOrder_applySaleTradeCondition(batch_mode=1, force=1)

      # Check compatibility with previous template
      assert open_order.getSpecialise() == specialise

    if open_order_line is not None:
      open_order = open_order_line.getParentValue()

      assert open_order_line.getResource() == 'service_module/slapos_compute_node_subscription'
      assert open_order_line.getQuantityUnit() == 'unit/piece'
      assert open_order_line.getBaseContribution() == 'base_amount/invoicing/discounted'
      assert open_order_line.getBaseContributionList()[1] == 'base_amount/invoicing/taxable'
      assert open_order_line.getUse() == 'trade/sale'
      #assert open_order_line.getPrice() == 1, open_order_line.getPrice()
      #assert open_order_line.getQuantity() == 1

      # XXX TODO open_order.OpenSaleOrder_updatePeriod()

    # Person_storeOpenSaleOrderJournal should fix all divergent Instance Tree in one run
    # assert instance_tree.getCausalityState() == 'solved'
    return open_order
